commit 9b9528939a593b893c49568c13df1d59f89adf4b
Author: freddy77 <freddy77>
Date:   Sun Nov 29 20:16:36 2009 +0000

    Check error if conversion truncate data

diff --git a/ChangeLog b/ChangeLog
index 7a384df..6ecdf8d 100644
--- a/ChangeLog
+++ b/ChangeLog
@@ -1,3 +1,7 @@
+Sun Nov 29 21:16:19 CET 2009    Frediano Ziglio <freddy77_A_gmail_D_com>
+	* src/odbc/unittests/getdata.c:
+	- Check error if conversion truncate data
+
 Sun Nov 29 21:06:18 CET 2009    Frediano Ziglio <freddy77_A_gmail_D_com>
 	* src/odbc/unittests/data.c: Fix MS ODBC problem during test
 
@@ -1935,4 +1939,4 @@ Wed Jan  9 19:54:43 EST 2008	JK Lowden <jklowden@freetds.org>
 	* ChangeLog-0.82 added because of release
 	
 $FreeTDS$
-$Id: ChangeLog,v 1.2894 2009/11/29 20:06:28 freddy77 Exp $
+$Id: ChangeLog,v 1.2895 2009/11/29 20:16:36 freddy77 Exp $
diff --git a/src/odbc/unittests/getdata.c b/src/odbc/unittests/getdata.c
index f67701c..8a02da3 100644
--- a/src/odbc/unittests/getdata.c
+++ b/src/odbc/unittests/getdata.c
@@ -1,7 +1,7 @@
 #include "common.h"
 #include <assert.h>
 
-static char software_version[] = "$Id: getdata.c,v 1.11 2009/11/27 16:16:39 freddy77 Exp $";
+static char software_version[] = "$Id: getdata.c,v 1.12 2009/11/29 20:16:36 freddy77 Exp $";
 static void *no_unused_var_warn[] = { software_version, no_unused_var_warn };
 
 static char odbc_err[256];
@@ -67,6 +67,7 @@ main(int argc, char *argv[])
 	char buf[32];
 	SQLINTEGER int_buf;
 	SQLLEN len;
+	SQLRETURN rc;
 
 	Connect();
 
@@ -165,6 +166,40 @@ main(int argc, char *argv[])
 
 	ResetStatement();
 
+
+	/* test int to truncated string */
+	Command("SELECT CONVERT(INTEGER, 12345)");
+	CHKFetch("S");
+
+	/* error 22003 */
+	CHKGetData(1, SQL_C_CHAR, buf, 4, NULL, "E");
+	ReadError();
+	if (strcmp(odbc_sqlstate, "22003") != 0) {
+		fprintf(stderr, "Unexpected sql state %s returned\n", odbc_sqlstate);
+		Disconnect();
+		exit(1);
+	}
+	CHKGetData(1, SQL_C_CHAR, buf, 2, NULL, "No");
+	ResetStatement();
+
+	/* test unique identifier to truncated string */
+	rc = Command2("SELECT CONVERT(UNIQUEIDENTIFIER, 'AA7DF450-F119-11CD-8465-00AA00425D90')", "SENo");
+	if (rc != SQL_ERROR) {
+		CHKFetch("S");
+
+		/* error 22003 */
+		CHKGetData(1, SQL_C_CHAR, buf, 17, NULL, "E");
+		ReadError();
+		if (strcmp(odbc_sqlstate, "22003") != 0) {
+			fprintf(stderr, "Unexpected sql state %s returned\n", odbc_sqlstate);
+			Disconnect();
+			exit(1);
+		}
+		CHKGetData(1, SQL_C_CHAR, buf, 2, NULL, "No");
+	}
+	ResetStatement();
+
+
 	Disconnect();
 
 	use_odbc_version3 = 1;

